                processor 6502
                include "vcs.h"
                include "macro.h"

ARENA_HEIGHT = 93

                SEG.U vars
                ORG $80			
				
OverscanValue:	ds 1
Frame:          ds 1   
Score:          ds 2  
Temp			ds 1
Rand16			ds 1
Rand8			ds 1
Rand			ds 1
PlayerX			ds 2
PlayerY			ds 2
Player0Ptr:         ds 2    ; used for drawing player0
Player1Ptr:         ds 2    ; used for drawing player1
Player0Draw:        ds 1    ; used for drawing player0
Player1Draw:        ds 1    ; used for drawing player1
Color1Ptr:          ds 2    ; used for coloring player0 
Color1:             ds 1    ; used for coloring player0
GameRunning			ds 1
DigitOnes:      ds 2    ; stored in $82-83, DigitOnes = Score, DigitOnes+1 = Score+1
DigitTens:      ds 2    ; stored in $84-85, DigitTens = Score, DigitTens+1 = Score+1
ScoreCounter:   ds 1
PlayerXDir: ds 1
PlayerYDir: ds 1
RoomNumber: ds 1
PotionTimer: ds 1
GhostAnim: ds 1
vec: ds 2
ScreenDrawing: ds 1
GhostMovingTimer: ds 1
GhostMovingDirTimer: ds 1

                SEG code
                ORG $F800	; FC00 for a one k game
				
Random:
        lda Rand
        lsr
 ifconst Rand16
        rol Rand16
 endif
        bcc noeor
        eor #$B4 
noeor 
        sta Rand
 ifconst Rand8
        eor Rand16
 endif
        rts 			
		
Reset
   ; Clear RAM and all TIA registers
    CLEAN_START   
	
Reset1	
	lda #$C6
	sta COLUBK
	sta Rand16
	sta Rand

	lda #$46
	sta COLUP0	

	lda #106
	sta PlayerY+0
	
	lda #16
	sta Score	
	
	lda #10
	sta Score+1
	
	lda #76
	sta PlayerX+0
	
	lda #0
	sta RoomNumber
	sta AUDV0
	sta PlayerY+1
	sta PotionTimer
	sta GhostAnim
	sta GhostMovingTimer
	sta NUSIZ1

Game_not_started	
	lda #130
	sta PlayerX+1
	
	jsr Crap2
	
	lda INPT4           ; read the player's fire button value	
	bpl Game_begin
	
	lda #15
	sta OverscanValue	

	jmp Game_not_started

Crap2:
		jsr VerticalSync
		jsr VerticalBlank2
		jsr Kernel	
		sta CXCLR
		
		jsr Overscan        ; Jump to SubRoutine OverScan
		rts
		
Game_begin:
	lda #14
	sta OverscanValue	
	
	lda #66
	sta PlayerY+0	
	
	lda #1
	sta RoomNumber

		jsr Crap

FirePressed2
		jmp GameLoop
		
Crap
		lda SWCHB                        ; read the console switches
		lsr                              ; shift game reset to carry
		bcs .skipReset                   ; skip game reset

		lda #12
		sta OverscanValue
		jsr Crap2

		jmp Reset1

.skipReset 
		jsr VerticalSync
		jsr VerticalBlank
		jsr Kernel	
		jsr Overscan        ; Jump to SubRoutine OverScan
		
		rts

Go_to_Loop3:
		jsr VerticalSync
		jsr VerticalBlank
		jsr Kernel
	
		jsr Overscan        ; Jump to SubRoutine OverScan

		lda SWCHB                        ; read the console switches
		lsr                              ; shift game reset to carry
		bcs Go_to_Loop3                   ; skip game reset
		
		jmp Reset1

GameLoop
		jsr Crap
		
        lda Score  ; get position of player
        cmp #$00      ; test for edge of screen
        bne GameLoop

        lda Score+1  ; get position of player
        cmp #$0A       ; test for edge of screen
        bne GameLoop

		lda #25
		sta OverscanValue
		jsr Crap2

		jmp Reset1
		
VerticalSync:
        lda #$82        ; DGS - LoaD Accumulator with $82 so D7=1 and D1=1
        ldx #48         ; LoaD X with 49
        sta WSYNC       ; Wait for SYNC (halts CPU until end of scanline)
        sta VSYNC       ; Accumulator D1=1, turns on Vertical Sync signal
        sta VBLANK      ; DGS - turn off video, dump paddles to ground
        stx TIM64T      ; set timer to go off in 41 scanlines (49 * 64) / 76
        ;sta CTRLPF      ; D1=1, playfield now in SCORE mode
        lda Frame
        and #$3f
        bne VSskip
VSskip: inc Frame       ; increment Frame count

        sta WSYNC   ; Wait for Sync - halts CPU until end of 1st scanline of VSYNC

        sta WSYNC   ; wait until end of 2nd scanline of VSYNC
        lda #0      ; LoaD Accumulator with 0 so D1=0
        sta PF0     ; blank the playfield
        sta PF1     ; blank the playfield
        sta PF2     ; blank the playfield
        sta GRP0    ; blanks player0 if VDELP0 was off
        sta GRP1    ; blanks player0 if VDELP0 was on, player1 if VDELP1 was off 
        sta GRP0    ; blanks                           player1 if VDELP1 was on		
        sta VDELP0  ; turn off Vertical Delay
        sta VDELP1  ; turn off Vertical Delay
        ;sta CXCLR   ; clear collision detection latches
        sta WSYNC   ; wait until end of 3rd scanline of VSYNC
        sta VSYNC   ; Accumulator D1=0, turns off Vertical Sync signal
Sleep12:            ;       jsr here to sleep for 12 cycles        
        rts         ; ReTurn from Subroutine

VerticalBlank:    
		jsr Collisions	
        jsr Random 
		jsr Joystick
		jsr PositionPlayers
	
		rts
		
VerticalBlank2:    
        jsr Random 
		jsr PositionPlayers
		
		rts
			
PositionPlayers:
        ldx #1              ; position players 0 and 1
POloop:
        lda PlayerX,x       ; get the Player's X position
        jsr PosPlayer       ; set coarse X position and fine-tune amount 
        dex                 ; DEcrement X
        bpl POloop          ; Branch PLus so we position all Players
        sta WSYNC           ; wait for end of scanline
        sta HMOVE           ; Tell TIA to use fine-tune values to set final X positions
                
    ; Player0Draw = ARENA_HEIGHT + HUMAN_HEIGHT - Y_position
        lda #(ARENA_HEIGHT + Cranberry_HEIGHT)
        sec
        sbc PlayerY
        sta Player0Draw
        
    ; Set Player0Ptr to proper value for drawing player0
        lda #<(CranberryGFX + Cranberry_HEIGHT - 1)
        sec
        sbc PlayerY
        sta Player0Ptr
        lda #>(CranberryGFX + Cranberry_HEIGHT - 1)
        sbc #0
        sta Player0Ptr+1
    
		lda RoomNumber
		cmp #4
		beq Draw_Potion	    
		
Draw_Ghost:		
		lda #14
		sta COLUP1	

    ; Player1Draw = ARENA_HEIGHT + BOX_HEIGHT - Y_position
        lda #(ARENA_HEIGHT + Ghost_HEIGHT)
        sec
        sbc PlayerY+1
        sta Player1Draw        
        
	inc GhostAnim
	
	ldx GhostAnim
	cpx #8
	bpl Ghost_frame2	 		
		
    ; Set Player1Ptr to proper value for drawing player1
        lda #<(GhostGFX + Ghost_HEIGHT - 1)
        sec
        sbc PlayerY+1
        sta Player1Ptr
        lda #>(GhostGFX + Ghost_HEIGHT - 1)
        sbc #0
        sta Player1Ptr+1
        
			jmp PrepScoreForDisplay	
		
Ghost_frame2:		
    ; Set Player1Ptr to proper value for drawing player1
        lda #<(Ghost2GFX + Ghost2_HEIGHT - 1)
        sec
        sbc PlayerY+1
        sta Player1Ptr
        lda #>(Ghost2GFX + Ghost2_HEIGHT - 1)
        sbc #0
        sta Player1Ptr+1		
		
	ldx GhostAnim
	cpx #16
	beq Reset_Ghostanim_timer		
		
		jmp PrepScoreForDisplay
		
Reset_Ghostanim_timer:
		ldx #0
		stx GhostAnim

		jmp PrepScoreForDisplay

Draw_Potion:
		lda #44
		sta COLUP1	

    ; Player1Draw = ARENA_HEIGHT + BOX_HEIGHT - Y_position
        lda #(ARENA_HEIGHT + Potion_HEIGHT)
        sec
        sbc PlayerY+1
        sta Player1Draw        
        
    ; Set Player1Ptr to proper value for drawing player1
        lda #<(PotionGFX + Potion_HEIGHT - 1)
        sec
        sbc PlayerY+1
        sta Player1Ptr
        lda #>(PotionGFX + Potion_HEIGHT - 1)
        sbc #0
        sta Player1Ptr+1
		
PrepScoreForDisplay:
        ; initialize the loop counter for the score        
        ldx #5
        stx ScoreCounter
        
        ldx #1          ; use X as the loop counter for PSFDloop
PSFDloop:
        lda Score,x     ; LoaD A with Score+1(first pass) or Score(second pass)
        and #$0F        ; remove the tens digit
        sta Temp        ; Store A into Temp
        asl             ; Accumulator Shift Left (# * 2)
        asl             ; Accumulator Shift Left (# * 4)
        adc Temp        ; ADd with Carry value in Temp (# * 5)
        sta DigitOnes,x  ; STore A in DigitOnes+1(first pass) or DigitOnes(second pass)
        lda Score,x     ; LoaD A with Score+1(first pass) or Score(second pass)
        and #$F0        ; remove the ones digit
        lsr             ; Logical Shift Right (# / 2)
        lsr             ; Logical Shift Right (# / 4)
        sta Temp        ; Store A into Temp
        lsr             ; Logical Shift Right (# / 8)
        lsr             ; Logical Shift Right (# / 16)
        adc Temp        ; ADd with Carry value in Temp ((# / 16) * 5)
        sta DigitTens,x ; STore A in DigitTens+1(first pass) or DigitTens(second pass)
        dex             ; DEcrement X by 1
        bpl PSFDloop    ; Branch PLus (positive) to PSFDloop
        rts             ; ReTurn from Subroutine  					
		
Kernel:  
		;sleep 2

		lda #$AA
		sta COLUPF		
		
		sta WSYNC       ; Wait for SYNC (halts CPU until end of scanline)
;---------------------------------------                
        lda INTIM       ; 4  4 - check the timer
        bne Kernel      ; 2  6 - (3 7) Branch if its Not Equal to 0
    ; turn on the display
        sta VBLANK      ; 3  9 - Accumulator D1=0, turns off Vertical Blank signal (image output on)        
		lda #$11          ; 2 11
		sta CTRLPF      ; 3 14 - turn on playfield mirroring
		
		; these 4 lines are duplicated after the inc DigitOnes/Tens 		
        ldy DigitTens           ; 3 54 - get the tens digit offset for the Score
        lda DigitFlippedGfx,y   ; 5 59 -   use it to load the digit graphics
        and #$0F                ; 2 61 -   remove the graphics for the ones digit
        sta Temp                ; 3 64 -   and save it
		
ScoreLoop2:                     ;   51 from bne ScoreLoop2
        ; calculate PF2 for left side of screen
        ldy DigitOnes           ; 3 54 - get the ones digit offset for the Score
        lda DigitFlippedGfx,y   ; 4 58 -   use it to load the digit graphics
        and #$F0                ; 2 60 -   remove the graphics for the tens digit
        ora Temp                ; 3 63 -   merge with the tens digit graphics
		tax                     ; 2 65 - save in X for later		
        sta WSYNC               ; 3 68 - wait for end of scanline
;---------------------------------------  
        stx PF2                 ; 3  3 - update PF2 for left side of screen
        ldy DigitOnes+1         ; 3  6 - get the left digit offset for the Score+1
        lda DigitGfx,y          ; 4 10 -   use it to load the digit graphics
        and #$0F                ; 2 12 -   remove the graphics for the ones digit
        sta Temp                ; 3 15 -   and save it
        ldy DigitTens+1         ; 3 18 - get the ones digit offset for the Score+1
        lda DigitGfx,y          ; 4 22 -   use it to load the digit graphics
        and #$F0                ; 2 24 -   remove the graphics for the tens digit
        ora Temp                ; 3 27 -   merge with the tens digit graphics
        jsr Sleep12             ;12 39
        SLEEP 6                ; 6 45
        sta PF2                 ; 3 48 - @48 - update PF2 for right side of screen
        sta WSYNC               ; 3 53 - wait for end of scanline		
;---------------------------------------
        stx PF2                 ; 3  3 - update PF2 for left side of screen
        tax                     ; 2  5 - save in X for right side
        inc DigitOnes           ; 5 10 - advance for the next line of graphic data
        inc DigitOnes+1         ; 5 15 - advance for the next line of graphic data
        inc DigitTens           ; 5 20 - advance for the next line of graphic data
        inc DigitTens+1         ; 5 25 - advance for the next line of graphic data
        ldy DigitTens           ; 3 28 - get the tens digit offset for the Score
        lda DigitFlippedGfx,y   ; 4 32 -   use it to load the digit graphics
        and #$0F                ; 2 34 -   remove the graphics for the ones digit
        sta Temp                ; 3 37 -   and save it
        dec ScoreCounter        ; 5 42 - decrement score loop counter
        SLEEP 3                 ; 3 45
        stx PF2                 ; 3 48
        bne ScoreLoop2          ; 2 50 - (3 51) if ScoreCounter != 0 then branch to ScoreLoop
        sta WSYNC       ; 3 45 - wait for end of scanline

		lda #0
		sta PF1
		sta PF2			
		sta ScreenDrawing

		ldy #ARENA_HEIGHT   ;        init loop counter

        lda RoomNumber
        cmp #$00      ; test for edge of screen
        beq Title_barren

        jmp Draw_People_Tree	
		
Ghost_:
			jmp Ghost
		
Title_barren:

			sta WSYNC
				inc ScreenDrawing
			
				ldx ScreenDrawing
				cpx #66
				beq StopDrawing
				
				jmp Draw_sprites_routine_

StopDrawing:
		rts

Draw_sprites_routine_
	jmp Draw_sprites_routine
		
The_Trees___:
	jmp The_Trees
				
Maze_:
	jmp Maze
	
RoomVecLO2
	.byte <Title_barren
	.byte <Title_barren
	.byte <The_Trees
	.byte <Ghost
	.byte <Title_barren
	.byte <Maze	
	.byte <GhostTrio	
	
RoomVecHI2
	.byte >Title_barren
	.byte >Title_barren
	.byte >The_Trees
	.byte >Ghost
	.byte >Title_barren
	.byte >Maze	
	.byte >GhostTrio
	
Draw_People_Tree:
	sta WSYNC

    ldx RoomNumber
    lda RoomVecLO2,x
    sta vec                 ; 'vec' is a two-byte zero-page variable
    lda RoomVecHI2,x
    sta vec+1
    jmp (vec)
				
GhostTrio:		
				lda #6
				sta NUSIZ1

				inc GhostMovingTimer
				inc GhostMovingTimer				
				
				lda GhostMovingTimer
				
				cmp #128
                beq Move_ghosts
				
		        cmp #0
                beq Move_ghosts
				
				jmp GhostTrioPF
				
Move_ghosts:
				lda GhostMovingDirTimer
		        and #1
                beq Move_ghosts_up

				inc PlayerY+1
				
				lda PlayerY+1
				cmp #91
                beq Change_Ghosts_dir

				jmp GhostTrioPF
				
Move_ghosts_up:
				dec PlayerY+1
				
				lda PlayerY+1
		        cmp #71
                beq Change_Ghosts_dir

				jmp GhostTrioPF
				
Change_Ghosts_dir:
				inc GhostMovingDirTimer	
					
GhostTrioPF:
				lda #$6
				sta COLUPF

				lda ScreenDrawing
                cmp #18
                bcc GhostTrioPF3
	
		        cmp #22
                bcc GhostTrioPF1	
							
		        jmp GhostTrioPF2
			
	
GhostTrioPF1:				
				lda #%11111111
				sta PF1
				sta PF2

				jmp Draw_Cranberry_with_pf

GhostTrioPF2:
				lda #0
				sta PF1
				
				lda #%00011000
				sta PF2
				
				jmp Draw_Cranberry_with_pf
				
GhostTrioPF3:
				lda #%00000000
				sta PF1
				sta PF2
				
				jmp Draw_Cranberry_with_pf
				
Ghost:
				inc GhostMovingTimer
				inc GhostMovingTimer
	
				ldx GhostMovingTimer
				beq Ghost_moving

				jmp Draw_Cranberry_with_pf

Ghost_moving:
				lda #0
				sta GhostMovingTimer

			    lda PlayerX+1
				cmp PlayerX+0        ; test for edge of screen
				bcs Move_ghost_left
		
				inc PlayerX+1
		
				jmp Ghost_y

Move_ghost_left:
				dec PlayerX+1
				
Ghost_y:			
			    lda PlayerY+1
				cmp PlayerY+0        ; test for edge of screen
				bcs Move_ghost_up
		
				inc PlayerY+1
		
				jmp Draw_Cranberry_with_pf

Move_ghost_up:
				dec PlayerY+1
				jmp Draw_Cranberry_with_pf

Maze:
				lda #$18
				sta COLUPF

				lda ScreenDrawing
                cmp #10
                bcc Maze1
	
		        cmp #52
                bcc Maze2
							
                jmp Maze3
	
Maze1:				
				lda #%00001000
				sta PF1				
				sta PF2			

				jmp Draw_Cranberry_with_pf

Maze2:		
				lda #%00001001
				sta PF1
				
				lda #%10001000
				sta PF2				
				
				jmp Draw_Cranberry_with_pf

Maze3:		
				lda #%10000000
				sta PF2
				
				lda #%00000001
				sta PF1	
				
				jmp Draw_Cranberry_with_pf
						
The_Trees
				lda ScreenDrawing
                cmp #18
                bcc Trees3
	
		        cmp #28
                bcc Trees2	
		
                cmp #38
                bcc Trees1
							
		        jmp Trees3
	
Trees1:				
				sta WSYNC
				lda #$F4
				sta COLUPF
				
				lda #%00001000
				sta PF1

				jmp Draw_Cranberry_with_pf

Trees2:
				sta WSYNC

				lda #$C4
				sta COLUPF
				
				lda #%00011100
				sta PF1
				
				jmp Draw_Cranberry_with_pf

StopDrawing_
	jmp StopDrawing

Trees3:		
				sta WSYNC
				lda #0
				sta PF1
		
Draw_Cranberry_with_pf:


				inc ScreenDrawing
			
				ldx ScreenDrawing
				cpx #66
				beq StopDrawing_
				
				
Draw_sprites_routine
        lda #Cranberry_HEIGHT-1 ; 2 13 - height of the human graphics, 
        dcp Player0Draw     ; 5 18 - Decrement Player0Draw and compare with height
        bcs DoDrawGrp0aaa      ; 2 20 - (3 21) if Carry is Set then player0 is on current scanline
        lda #0              ; 2 22 - otherwise use 0 to turn off player0
        .byte $2C           ; 4 26 - $2C = BIT with absolute addressing, trick that
                            ;        causes the lda (Player0Ptr),y to be skipped
DoDrawGrp0aaa:                 ;   21 - from bcs DoDrawGRP0
        lda (Player0Ptr),y  ; 5 26 - load the shape for player0
        tax                 ; 2 28 - save in X for update during Horizontal Blanking

        lda #Ghost_HEIGHT-1   ; 2 30 - height of the box graphics, subtract 1 due to starting with 0
        dcp Player1Draw     ; 5 35 - Decrement Player1Draw and compare with height
        bcs DoDrawGrp1a      ; 2 37 - (3 38) if Carry is Set, then player1 is on current scanline
        lda #0              ; 2 39 - otherwise use 0 to turn off player1
        .byte $2C           ; 4 43 - $2C = BIT with absolute addressing, trick that
                            ;        causes the lda (Player1Ptr),y to be skipped
DoDrawGrp1a:                 ;   38 - from bcs DoDrawGrp1
        lda (Player1Ptr),y  ; 5 43 - load the shape for player1
        
        sta WSYNC           ; 3 46/0 - halts CPU until start of next scanline
        stx GRP0            ; 3  3 - draw the human
        sta GRP1            ; 3  6 - draw the box
        dey                 ; 2  8 - update loop counter
        bne Draw_People_Tree_____	    ; 2 10 - 3 11 if taken	
		
		rts

Draw_People_Tree_____
	jmp Draw_People_Tree
		
		
Overscan
        sta WSYNC   ; Wait for SYNC (start of next scanline)
        lda #2      ; LoaD Accumulator with 2
        sta VBLANK  ; STore Accumulator to VBLANK, D1=1 turns image output off
        lda OverscanValue  	; previously OverscanValue
        sta TIM64T  ; set timer for end of Overscan
OSwait:
        sta WSYNC
        bit TIMINT
        bpl OSwait  ; wait for the timer to denote end of Overscan
		rts
	
PFdidCollideFFFFF
		jmp PFdidCollide
		
Potion_touched:
		ldx PotionTimer
		inx 
		stx PotionTimer
		
		ldx PotionTimer
		stx AUDF0
		
		ldx #4
		stx AUDV0
		
		ldx #12
		stx AUDC0
		
		ldx #0
		stx PlayerY+1
		
Potion_touched_working:
		jsr Increase_score
		
		ldx PotionTimer
		cpx #10
		beq DonePotion	
		
		rts

DonePotion:
		lda #0
		sta PotionTimer
		sta AUDV0
		
		sta CXCLR	

		rts
	
DoneWithJoystick2____
		lda RoomNumber
		cmp #4
		beq Potion_touched	  

		jmp DoneWithJoystick2
	
Collisions:	
        lda CXP0FB     ; check to see if player0 collided with playfield
		and #$80           
        bne  PFdidCollideFFFFF
		
        lda CXPPMM     ; check to see if player0 collided with player1
		and #$80           
        bne DoneWithJoystick2____
		
FFFFFF	
		lda #0
		sta AUDV0

		rts

PosPlayer:
        sec
        sta WSYNC
DivideLoop
        sbc #15        ; 2  2 - each time thru this loop takes 5 cycles, which is 
        bcs DivideLoop ; 2  4 - the same amount of time it takes to draw 15 pixels
        eor #7         ; 2  6 - The EOR & ASL statements convert the remainder
        asl            ; 2  8 - of position/15 to the value needed to fine tune
        asl            ; 2 10 - the X position
        asl            ; 2 12
        asl            ; 2 14
        sta.wx HMP0,X  ; 5 19 - store fine tuning of X
        sta RESP0,X    ; 4 23 - set coarse X position of Player
        rts            ; 6 29 - ReTurn from Subroutine		

EndItItsNotPressed:
		sta CXCLR
		rts

GetNewRoom_FFFF 
	jmp GetNewRoom

Joystick:
        lda CXP0FB     ; check to see if player collided with playfield
		and #$80           
        bne DoneWithJoystick

		ldy #0
		sty PlayerXDir
		sty PlayerYDir

		lda SWCHA       ; fetch state of both joysticks
  
        asl             ; shift A bits left, R is now in carry bit
        bcs CheckLeft   ; branch if joystick is not held right
		
Move_Right:	
        ldy PlayerX+0   ; get position of player
        iny             ; and move it right
        cpy #150        ; test for edge of screen
        beq GetNewRoom_FFFF       ; save value as is if we're not at edge
	
		sty PlayerX+0    ; save player's new X position

		ldy #1
		sty PlayerXDir

CheckLeft:
        asl             ; shift A bits left, L is now in the carry bit
        bcs CheckDown  ; branch if joystick not held left
	
Move_Left:
        ldy PlayerX+0    ; get the Player's X position
        dey             ; and move it left
        cpy #3       ; test for edge of screen
        bne SaveX2      ; save X if we're not at the edge
        ldy #4       ; else wrap to right edge
		
SaveX2:
		sty PlayerX+0     ; save player's new X position

		ldy #255
		sty PlayerXDir

CheckDown:
        asl                     ; shift A bits left, D is now in the carry bit
        bcs CheckUp             ; branch if joystick not held down

Move_Down:	
		ldy #1
		sty PlayerYDir

		ldy PlayerY+0
		cpy #34           ; test for bottom of screen
		beq SaveY
	
        ldy PlayerY+0            ; get the Player's Y position
        dey                     ; move it down
		sty PlayerY+0
 
        jmp DoneWithJoystick
		
SaveY: 
		sty PlayerY+0            ; save Y

		jmp DoneWithJoystick

CheckUp:
        asl                     ; shift A bits left, U is now in the carry bit
        bcs DoneWithJoystick    ; branch if joystick not held up	

Move_Up:
		ldy #255
		sty PlayerYDir	
		
		ldy PlayerY+0
		cpy #92           ; test for bottom of screen
		beq SaveY2

        ldy PlayerY+0             ; get the Player's Y position
        iny                     ; move it up		
		sty PlayerY+0
			
        jmp DoneWithJoystick
		
SaveY2: 	
		sty PlayerY+0             ; save Y
		
DoneWithJoystick:
        rts
   
PFdidCollide:
		lda #4
		sta AUDV0
		
		lda #14		
		sta AUDC0
		sta AUDF0
		
		ldx PlayerXDir		; hundreds digit!
		cpx #255
		beq Move_Left2			
		
		ldx PlayerXDir		; hundreds digit!
		cpx #1
		beq Move_Right2

		jmp Check_Y_PF
		
Move_Right2:	
        ldy PlayerX+0   ; get position of player
        dey             ; and move it right
		sty PlayerX+0    ; save player's new X position

		jmp Check_Y_PF

Move_Left2:
        ldy PlayerX+0    ; get the Player's X position
        iny             ; and move it left
		sty PlayerX+0     ; save player's new X position

Check_Y_PF
		ldx PlayerYDir		; hundreds digit!
		cpx #255
		beq Move_Up2			
		
		ldx PlayerYDir		; hundreds digit!
		cpx #1
		beq Move_Down2

		jmp DoneWithJoystick2

Move_Down2:	
        ldy PlayerY+0            ; get the Player's Y position
        iny                     ; move it down
        iny                     ; move it down			
		sty PlayerY+0            ; save Y

		jmp DoneWithJoystick2

Move_Up2:
        ldy PlayerY+0             ; get the Player's Y position
        dey                     ; move it up
        dey                     ; move it up		
		sty PlayerY+0             ; save Y

DoneWithJoystick2:
		jsr Decrease_score
		
		sta CXCLR
		
        rts

GetNewRoom:
        lda RoomNumber  ; get position of player
        cmp #6	        ; test for edge of screen
        beq No_new_room

		inc RoomNumber

		ldy #20
		sty PlayerX+0

    ldx RoomNumber
    lda RoomVecLO,x
    sta vec                 ; 'vec' is a two-byte zero-page variable
    lda RoomVecHI,x
    sta vec+1
    jmp (vec)

No_new_room:	
		rts		
		
RoomVecLO
	.byte <Room1
	.byte <Room2
	.byte <Room3
	.byte <Room4
	.byte <Room5
	.byte <Room6
	.byte <Room7
	
RoomVecHI
	.byte >Room1
	.byte >Room2
	.byte >Room3
	.byte >Room4
	.byte >Room5	
	.byte >Room6
	.byte >Room7

	; room info is room+1

Room1:	
		rts
		
Room2:
		ldy #180
		sty PlayerX+1
		sty PlayerY+1	
		rts
			
Room3:		
		rts

Room4:
		ldy #120
		sty PlayerX+1

		ldy PlayerY+0
		sty PlayerY+1		
		rts

Room5:
		ldy #120
		sty PlayerX+1
		ldy #40
		sty PlayerY+1

		rts

Room6:
		ldy #0
		sty PF0

		ldy #120
		sty PlayerY+1

		rts

Room7:
		ldy #80
		sty PlayerY+1
		
		ldy #43
		sty PlayerX+1
				
		ldy #0
		sty GhostMovingTimer
				
		rts

Increase_score:
        lda Score  ; get position of player
        cmp #16        ; test for edge of screen
        bcs Finish_Increasing_Score
		
        sed             ; turn on decimal mode
        clc
        lda Score+1     ; Score+1 holds the Tens and Ones digits
        adc #10
        sta Score+1
        lda Score       ; Score holds the Thousands and Hundreds digits
        adc #0          ; add 0 to this digit, carry will inc by 1 if needed
        sta Score       ;
        cld             ; turn off decimal mode	

Finish_Increasing_Score:
		rts
		
Decrease_score:
        sed             ; turn on decimal mode
        sec
        lda Score+1     ; Score+1 holds the Tens and Ones digits
        sbc #$10
        sta Score+1
		
        lda Score       ; Score holds the Thousands and Hundreds digits
        sbc #0          ; add 0 to this digit, carry will inc by 1 if needed
        sta Score       ;
		
        cld             ; turn off decimal mode
		
		rts
		
DigitGfx:
        .byte %00100010
        .byte %01010101
        .byte %01010101
        .byte %01010101
        .byte %00100010
        
        .byte %00100010
        .byte %01100110
        .byte %00100010
        .byte %00100010       
        .byte %01110111
        
        .byte %01100110
        .byte %00010001
        .byte %01100110
        .byte %01000100
        .byte %01110111
        
        .byte %01100110
        .byte %00010001
        .byte %01100110
        .byte %00010001
        .byte %01100110
        
        .byte %01010101
        .byte %01010101
        .byte %01110111
        .byte %00010001
        .byte %00010001
        
        .byte %01110111
        .byte %01000100
        .byte %01100110
        .byte %00010001
        .byte %01100110

        .byte %00110011
        .byte %01000100
        .byte %01100110
        .byte %01010101
        .byte %00100010
        
        .byte %01110111
        .byte %00010001
        .byte %00100010
        .byte %00100010
        .byte %00100010
        
        .byte %00100010
        .byte %01010101
        .byte %00100010
        .byte %01010101
        .byte %00100010

        .byte %00100010
        .byte %01010101
        .byte %00110011
        .byte %00010001
        .byte %01100110
		
        .byte %01010101
        .byte %00010001
        .byte %00100010
        .byte %01000100
        .byte %01010101
		
DigitFlippedGfx:
        .byte %01000100
        .byte %10101010
        .byte %10101010
        .byte %10101010
        .byte %01000100
        
        .byte %01000100
        .byte %01100110
        .byte %01000100
        .byte %01000100       
        .byte %11101110
        
        .byte %01100110
        .byte %10001000
        .byte %11101110
        .byte %00100010
        .byte %11101110
        
        .byte %01100110
        .byte %10001000
        .byte %01100110
        .byte %10001000
        .byte %01100110
        
        .byte %10101010
        .byte %10101010
        .byte %11101110
        .byte %10001000
        .byte %10001000
        
        .byte %11101110
        .byte %00100010
        .byte %01100110
        .byte %10001000
        .byte %01100110
           
        .byte %11001100
        .byte %00100010
        .byte %01100110
        .byte %10101010
        .byte %01000110
        
        .byte %11101110
        .byte %10001000
        .byte %01000100
        .byte %01000100
        .byte %01000100
        
        .byte %01000100
        .byte %10101010
        .byte %01000100
        .byte %10101010
        .byte %01000100
        
        .byte %01000100
        .byte %10101010
        .byte %11101110
        .byte %10001000
        .byte %01100110
		
        .byte %10101010
        .byte %10001000
        .byte %01000100
        .byte %00100010
        .byte %10101010

CranberryGFX
		.byte #%00111000	
		.byte #%01111100
		.byte #%01111100
		.byte #%00111000	
		
Cranberry_HEIGHT = * - CranberryGFX

GhostGFX
		.byte #%01010101
		.byte #%01111111	
		.byte #%01111111	
		.byte #%01111111	
		.byte #%01101011
		.byte #%01111111	
		.byte #%00111110
Ghost_HEIGHT = * - GhostGFX

Ghost2GFX
		.byte #%00101010
		.byte #%01111111	
		.byte #%01111111	
		.byte #%01111111	
		.byte #%01111111
		.byte #%01111111	
		.byte #%00111110
Ghost2_HEIGHT = * - Ghost2GFX

PotionGFX
		.byte #%01111110
		.byte #%11111111	
		.byte #%11111111	
		.byte #%01111110
		.byte #%00111100
		.byte #%00011000
		.byte #%00011000	
		.byte #%00011000
Potion_HEIGHT = * - PotionGFX

	echo "------", [$FFFA - *]d, "bytes free before you run out of space."

            ORG $FFFA

InterruptVectors
            .word Reset          ; NMI
            .word Reset          ; RESET
            .word Reset          ; IRQ

      END			